%{

#include <math.h>
#include <stdio.h>

int a=0, b=0, r=0;

%}

%s ARITH
%s ADD
%s MUL
%s SUB
%s RES
%s ERR

PLUS            [\+]
MINUS           [\-]
TIMES           [\*]
ASSIGN          :=
LETTER          [A-Za-z]
DIGIT           [0-9]
ID              {LETTER}({LETTER}|{DIGIT})*
SIGNEDINTEGER   ({PLUS}|{MINUS}){DIGIT}+
UNSIGNEDINTEGER {DIGIT}+
INTEGER         {SIGNEDINTEGER}|{UNSIGNEDINTEGER}
REAL            {INTEGER}(\.({DIGIT})*)?([eE]{INTEGER})?
WHITESPACE      [ \t]*
RETURN          [\n]


%%

<RES>.*[\n]       {printf( "-> %d\n ? ", r);
                   BEGIN 0;}

<ERR>.*[\n]       {printf( "? ");
                   BEGIN 0;}

<ADD>{INTEGER}    {b = atoi(yytext); 
                   r = a+b;
                   BEGIN RES;
                   }


<MUL>{INTEGER}    {b = atoi(yytext); 
                   r = a*b;
                   BEGIN RES;
                   }

<SUB>{INTEGER}     {b = atoi(yytext); 
                   r = a -b;
                   BEGIN RES;}

<ARITH>{SIGNEDINTEGER}  {b = atoi(yytext); 
                         r = a+b;
                    BEGIN RES;}
<ARITH>{UNSIGNEDINTEGER} {
                   printf( "Invalid arith operator: %s\n", yytext);
                   BEGIN ERR;
                  }
<ARITH>{PLUS}     { BEGIN 0; 
                    BEGIN ADD; }
<ARITH>{TIMES}    { BEGIN 0; 
                    BEGIN MUL; }
<ARITH>{MINUS}    { BEGIN 0; 
                    BEGIN SUB; }
<ARITH>{RETURN}   {r = a; 
                   printf( "-> %d\n ? ", r);
                   BEGIN 0;
                   }

{INTEGER}       { a = atoi(yytext); 
                  BEGIN ARITH; 
                }

{PLUS}|{TIMES}|{MINUS} {
                   printf( "Invalid arith operand: %s\n", yytext);
                   BEGIN ERR;
                 }

{WHITESPACE}      /* eat up white space */
{RETURN}           /* eat up white space */
 .               {
                   printf( "Invalid expression: %s\n", yytext);
                   BEGIN ERR;
                 }

%%




int main() {
     printf( "? ");
     yylex();
     return 0;
}



